#!/usr/bin/wish -f
#
## this is tkbroadcast version 3.0b1
## there is no documentation as yet other than the README
## Ethan Gold, July 1997 (etgold@cs.vassar.edu)

## the only command line options are "-iconic" and "-version"


## global variables
set version "3.0b1"
set rcfilepath $env(HOME)/.tkbcrc
set daemonfilepath $env(HOME)/.tkbcd
set rcfile ""
set port 5000
set insertfile ""

set metaserver localhost
set metaport 5500
set metadelay 30000

## globals to be set from resource file
set myport 0
set myname ""
set mycookie dkeirjti

## notification sound?
set sound 0
set soundpath /usr/local/student/lib/tkbc.au

set rcfile ""

## for dealing with overlapping incoming messages
set x 200
set y 200

## where to look for the machine name
set domainpath /etc/resolv.conf

## set userarray
set thelist ""
set userarray(dummy) dum
unset userarray(dummy)

## globals we're using to kludge inter procedure communication
set tomachine ""
set toport 0

## number of composing windows for multiple compose
#set winOutNum 0
set winInNum 0
set outnum 0
set innum 0

## send-to-all kludge
set allflag 0

######### end of gobal initializations ##############
#------------------------------------------------------------
## handle incoming messages
proc save {innum} {
    global filename env .incoming$innum

    if { [string compare $filename ""] == 0} {
	error "you must provide a filename before saving"
    } else {
	## do tilde expansion
	regsub "~/" $filename "$env(HOME)/" newfile
	regsub $env(USER) $env(HOME) "" tophome
	regsub "~" $newfile $tophome filename

	## replace spaces with _
	regsub -all " " $filename "_" filename
	set thetext [.incoming$innum.message get 0.0 end]
	set outfile [open $filename w]
	puts $outfile $thetext
	close $outfile
    }
}

proc reply {machine port} {
    global handle
    compose_and_send $machine $port
}

proc showincoming {info message} {
    global winInNum x y

    set winInNum [expr $winInNum + 1]
    set innum $winInNum

    ## get date - this uses GNU date from linux,
    ## may cause trouble elsewhere
    
    set date [exec date +%D\ %r]

    set inhandle [lindex $info 0]
    set inmachine [lindex $info 1]
    set inport [lindex $info 2]

    toplevel .incoming$innum
    wm geometry .incoming$innum +$x+$y

    scrollbar .incoming$innum.scroll -command ".incoming$innum.message yview"
    text .incoming$innum.message -width 50 -height 5 -wrap word -yscrollcommand ".incoming$innum.scroll set"
    button .incoming$innum.reply -text "Reply" -command [list reply $inmachine $inport]
    button .incoming$innum.close -text "Close" -command [list destroy .incoming$innum]
    button .incoming$innum.save -text "Save" -command [list save $innum]
    entry .incoming$innum.filename -text "tkbc.save" -textvariable filename
    label .incoming$innum.from -text "$inhandle@$inmachine:$inport     $date"

    pack .incoming$innum.from
    pack .incoming$innum.scroll -side left -fill y -pady 1m
    pack .incoming$innum.message -expand 1 -fill both
    pack .incoming$innum.reply -side right
    pack .incoming$innum.close -side right
    pack .incoming$innum.save -side right
    pack .incoming$innum.filename -side right

    .incoming$innum.message insert end $message

    bind .incoming$innum.message <KP_Enter> {
	reply $inmachine $inport
    }

    bind .incoming$innum.filename <KP_Enter> {
	reply $inmachine $inport
    }

    bind .incoming$innum.filename <Return> [list save $innum]

}

proc incoming { socket machine port } {
    global x y sound
    gets $socket info
    while { [gets $socket line] != -1 } {
	append message $line\n
    }
    if { $y > 600 } {
	set x 200
	set y 200
    }
    if { $sound } {
	catch {exec cat $soundpath > /dev/audio &}
    }
    ##catch {exec tkbroadcastshow.tcl -geometry +$x+$y $info $message &}
    showincoming $info $message
    set x [expr $x + 50]
    set y [expr $y + 50]
}

## end handling incoming messages

#------------------------------------------------------------
## this is the message composition and sending part

proc sendmessage {outnum} {
    global myname myport hostname tomachine toport
    global .outgoing$outnum

    ## for send-to-all kludge
    global allflag userarray
    
    set message [.outgoing$outnum.message get 0.0 end]

    if {$allflag} {
	puts "trying to send to all..."
	foreach user $userarray {
	    set mysock [socket [lindex $userarray($user) 0] \
		    [lindex $thelist($user) 1]]
	    puts $mysock "\"$myname\" $hostname $myport"
	    puts $mysock $message
	    close $mysock
	    set allflag 0
	}
    } else {
	set mysock [socket $tomachine $toport]
	puts $mysock "\"$myname\" $hostname $myport"
	puts $mysock $message
	close $mysock
    }
    destroy .outgoing$outnum
}

proc insert {outnum} {
    global env
    global .outgoing$outnum
    ## do tilde expansion, assuming everyone has the
    ## same $HOME/.. directory

    set insertfile [.outgoing$outnum.file get]
    regsub "~/" $insertfile "$env(HOME)/" newfile
    regsub $env(USER) $env(HOME) "" tophome
    regsub "~" $newfile $tophome file

    set infile [exec cat $file]
    .outgoing$outnum.message insert end $infile
}


proc compose_and_send {tomachine toport} {
    #global winOutNum
    global outnum x y

    #set winOutNum [expr $winOutNum + 1]
    #set outnum $winOutNum
    set  outnum [expr $outnum + 1]

    toplevel .outgoing$outnum
    set newx [expr 300 + $x % 20]
    set newy [expr 300 + $y % 20]
    wm geometry .outgoing$outnum +$newx+$newy

    scrollbar .outgoing$outnum.scroll -command ".outgoing$outnum.message yview"
    text .outgoing$outnum.message -width 50 -height 5 -wrap word -yscrollcommand ".outgoing$outnum.scroll set"
    entry .outgoing$outnum.file -textvariable file

    button .outgoing$outnum.send -text "Send" -command [list sendmessage $outnum]

    button .outgoing$outnum.cancel -text "Cancel" -command [list destroy .outgoing$outnum]

    button .outgoing$outnum.include -text "insert file" -command [list insert $outnum]

    pack .outgoing$outnum.scroll -side left -fill y -pady 1m
    pack .outgoing$outnum.message -expand 1 -fill both
    pack .outgoing$outnum.send -side right
    pack .outgoing$outnum.cancel -side right
    pack .outgoing$outnum.include -side right
    pack .outgoing$outnum.file -side right

    focus .outgoing$outnum.message

    bind .outgoing$outnum.message <KP_Enter> {
	sendmessage $outnum
    }

    bind .outgoing$outnum.file <Return> {
	insert $outnum
    }

    bind .outgoing$outnum.file <KP_Enter> {
	sendmessage $outnum
    }

}
## end compose and send stuff


#------------------------------------------------------------
## This is the top level "browser" window stuff

## define all the widgets for the main window

scrollbar .scroll -command ".names yview"
listbox .names -relief sunken -yscrollcommand ".scroll set"
entry .arbitrary -width 30 -relief sunken -textvariable whoname
button .arbsend -command {arbsend $whoname} -text "send to above"
#button .addname -command {addNew} -text "add new"
button .send -command {sendTest} -text "send"
button .close -command {quit} -text "close"
button .reread -command {changeRc} -text "reread"
button .personalinfo -command {personalInfo} -text "own info"
#button .sendtoall -command {sendAll} -text "All..."
#button .delete -command {deleteEntry} -text "delete entry"

## pack the main window
pack .scroll -side left -fill y -pady 1m
pack .names -side left -expand 1 -fill both -pady 1m
#pack .arbitrary .arbsend .send .reread .close
#pack .arbitrary .arbsend .send .sendtoall .addname .delete .personalinfo .reread .close
pack .arbitrary .arbsend .send .personalinfo .reread .close


proc findRc {} {
    ## check for the .tkbcrc file
    global rcfilepath rcfile
    if { [file exists $rcfilepath] } {
	set rcfile [open $rcfilepath r]
    } else {
	error "\$HOME/.tkbcrc missing. please enter your personal info."
	exec touch $rcfilepath
	set rcfile [open $rcfilepath r]	
    }
}


proc readRc {} {
    ## read in the rc file and set things up
    ## the rcfile will be of the format:
    ##   record(keyword) handle_name machine_name port_number
    ## the data will be stored in an array indexed on the handle
    ## name. the handle will be the text appearing in the selection
    ## box and will be used to key the data for that receipient.
    global rcfile userarray thelist myport myname
    global metaserver metaport mycookie metadelay
    while { [gets $rcfile line] != -1 } {
	#if { [regexp {^record\ .*} $line] } {
	#    set userarray([lindex $line 1]) [lrange $line 2 end]
	#}
	if { [regexp {^metaserver\ .*} $line] } {
	    set metaserver [lindex $line 1]
	    set metaport [lindex $line 2]
	}
	if { [regexp {metadelay\ .*} $line] } {
	    set metadelay [lindex $line 1]
	}
	if { [regexp {mycookie\ .*} $line] } {
	    set mycookie [lindex $line 1]
	}
	if { [regexp {myname\ .*} $line] } {
	    set myname [lindex $line 1]
	}
	if { [regexp {myport\ .*} $line] } {
	    set myport [lindex $line 1]
	}
	if { [regexp {^sound\ on.*} $line] } {
	    set sound 1
	}

	append thelist $line
    }
    close $rcfile
}


proc whoami {} {
    ## figure out name of local host and
    ## domain for outgoing messages

    global domainpath mydomain hostname

    ## parse /etc/resolve.conf for domainname
    set resolv [open $domainpath r]
    while { [gets $resolv line] != -1 } {
	if { [regexp {domain.*} $line] } {
	    set mydomain [lindex $line 1]
	} elseif { [regexp {search.*} $line] } {
	    set mydomain [lindex $line 1]
	}
    }
    
    ## get hostname and see if it is absolute
    set hostname [exec hostname]
    if { [regexp $mydomain $hostname] == 0 } {
	set hostname $hostname.$mydomain
    }
}

proc sendAll {} {
    set allflag 1
}

proc error {errormessage} {
    ## display an error message
    toplevel .error -class Dialog
    message .error.message -text "$errormessage"
    button .error.ok -text "Ok" -command {destroy .error}
    pack .error.message .error.ok
}

proc sendTest {} {
    ## catch selection errors from the send button
    global allflag

    if {$allflag} {
	send ""
    } else {
	if { [catch {selection get}] } {
	    error "you must select an entry first"
	} else {
	    send [selection get]
	}
    }
}

proc showNames {} {
    ## put the names into the listbox
    global userarray
    .names delete 0 end
    foreach name [array names userarray] {
	.names insert end $name
    }
}


proc deleteEntry {} {
    ## delete an entry from the name
    ## list and rcfile

    global rcfilepath
    
    if { [catch {selection get}] } {
	error "you must select an entry first"
    } else {
	set record [selection get]
	set newrc [open $rcfilepath.new w]
	set rcfile [open $rcfilepath r]
	while { [gets $rcfile line] != -1 } {
	    if { [regexp ".*$record.*" $line] } {
		continue
	    } else {
		puts $newrc $line
	    }
	}
	close $newrc
	close $rcfile
	exec mv $rcfilepath $rcfilepath.bak
	exec mv $rcfilepath.new $rcfilepath
	findRc
	reRead
    }   
}


proc doChange {newname newport} {
    ## helper function to do the actual
    ## personal name and port changes
    ## and restart the background daemon

    global myport myname rcfilepath daemonfilepath env sockflag
    global metaserver metaport metadelay
    set newrc [open $rcfilepath.new w]
    set rcfile [open $rcfilepath r]
    puts $newrc "myname \"$newname\""
    puts $newrc "myport $newport"
    puts $newrc "metaserver $metaserver $metaport"
    puts $newrc "metadelay $metadelay"
    while { [gets $rcfile line] != -1 } {
	if { [regexp {myname\ .*} $line] } {
	    continue
	} elseif { [regexp {myport\ .*} $line] } {
	    continue
	} elseif { [regexp {metaserver\ .*} $line] } {
	    continue
	} elseif { [regexp {metadelay\ .*} $line] } {
	    continue
	} else {
	    puts $newrc $line
	}
    }
    close $newrc
    close $rcfile
    exec mv $rcfilepath $rcfilepath.bak
    exec mv $rcfilepath.new $rcfilepath
    close $sockflag
    if { [catch {set sockflag [socket -server { incoming } $myport]}] != 0} {
	error "port busy. Try again"
    }
    
    findRc
    reRead
    metaUpdate
}



proc personalInfo {} {
    ## manage personal info:
    ## alias and port number

    global myname myport metaserver metaport
    toplevel .pInfo -class Dialog
    label .pInfo.aliaslabel -text "alias:"
    label .pInfo.portlabel -text "port:"
    label .pInfo.metalabel -text "metaserver:"
    label .pInfo.metaportlabel -text "metaserver port:"
    label .pInfo.metadelaylabel -text "metadelay:"
    entry .pInfo.alias -width 30 -relief sunken -textvariable myname
    entry .pInfo.port -width 10 -relief sunken -textvariable myport
    entry .pInfo.metaserver -width 30 -relief sunken -textvariable metaserver
    entry .pInfo.metaport -width 10 -relief sunken -textvariable metaport
    entry .pInfo.metadelay -width 10 -relief sunken -textvariable metadelay

    button .pInfo.close -text "close" -command {destroy .pInfo}
    button .pInfo.change -text "change" -command {doChange $myname $myport}

    pack .pInfo.aliaslabel .pInfo.alias
    pack .pInfo.portlabel .pInfo.port
    pack .pInfo.metalabel .pInfo.metaserver
    pack .pInfo.metaportlabel .pInfo.metaport
    pack .pInfo.metadelaylabel .pInfo.metadelay
    pack .pInfo.change -side left
    pack .pInfo.close -side right
    
}

proc changeRc {} {
    ## select an alternate resource file
    global rcfilepath

    toplevel .newRc -class Dialog
    label .newRc.filelabel -text "filename:"
    entry .newRc.file -width 30 -relief sunken -textvariable rcfilepath

    button .newRc.close -text "close" -command {destroy .newRc}
    button .newRc.change -text "read" -command {findRc; reRead; destroy .newRc}

    pack .newRc.filelabel .newRc.file
    pack .newRc.change -side left
    pack .newRc.close -side right

    bind .newRc.file <Return> {
	reRead; destroy .newRc
    }

    
}



proc doAdd {alias machine port} {
    ## add new record to rcfile

    global rcfilepath
    set rcfile [open $rcfilepath a]
    puts $rcfile "record \"$alias\" $machine $port"
    close $rcfile
    findRc
    reRead
}

proc addNew {} {
    ## add a new name from the entry widget
    ## to the rcfile and read it in again

    toplevel .newaddress -class Dialog
    label .newaddress.aliaslabel -text "alias:"
    label .newaddress.machinelabel -text "machine:"
    label .newaddress.portlabel -text "port:"
    entry .newaddress.alias -width 30 -relief sunken -textvariable newalias
    entry .newaddress.machine -width 30 -relief sunken -textvariable newmachine
    entry .newaddress.port -width 10 -relief sunken -textvariable newport
    button .newaddress.close -text "close" -command {destroy .newaddress}
    #button .newaddress.add -text "add" -command {doAdd $newalias \
	    $newmachine $newport}

    pack .newaddress.aliaslabel .newaddress.alias 
    pack .newaddress.machinelabel .newaddress.machine
    pack .newaddress.portlabel .newaddress.port
    pack .newaddress.add -side left
    pack .newaddress.close -side right
}

proc reRead {} {
    ## reread the resource file and update
    ## the address list widget
    global userarray
    foreach entry [array names userarray] {
	unset userarray($entry)
    }
    findRc
    readRc
    .names delete 0 end
    metaUpdate
    showNames
}

proc send {destination} {
    ## call the compose_and_send functions
    ## to create and send an outgoing message

    global userarray tomachine toport

    set tomachine [lindex $userarray($destination) 0]
    set toport [lindex $userarray($destination) 1]
    compose_and_send $tomachine $toport
}

proc arbsend {whoto} {
    ## send to an abritary destination
    ## from the entry box
    compose_and_send [lindex $whoto 0] [lindex $whoto 1]
}

proc quit {} {
    ## exit
    global rcfilepath
    exit
}


####################################
## Add as a new ID on the metaserver
####################################
proc addMe {} {
    global metadelay metaserver metaport
    global myname myport mycookie

    set metasock [socket $metaserver $metaport]
    #puts [gets $metasock]
    puts $metasock "add \"$myname\" $myport $mycookie"
    flush $metasock
    #puts [gets $metasock]
    close $metasock
    
}

################################
## update entry on metaserver
## and get latest userlist
################################
proc metaUpdate {} {
    global metadelay userarray metaserver metaport
    global myname myport mycookie
    upvar userarray userarray
    ## do update
    addMe
    #set metasock [socket $metaserver $metaport]
    #puts [gets $metasock]
    #puts $metasock "update \"$myname\" $mycookie"
    #flush $metasock
    #puts [gets $metasock]
    #close $metasock
    
    ## get userlist
    set metasock [socket $metaserver $metaport]
    gets $metasock metainfo
    puts $metasock "get"
    flush $metasock
    set status [gets $metasock]
    if {[string compare $status "OK"] == 0} {
	foreach entry [array names userarray] {
	    unset userarray($entry)
	}
	while { [gets $metasock line] >= 0 } {
	    set userarray([lindex $line 0]) [lrange $line 1 end]
	}
	showNames
    } else {
	puts $status
    }
    after $metadelay {metaUpdate}
}

##-------------------------------------------------
## begin running everything below this divider
##-------------------------------------------------


## check for the resource file
findRc

## read in the resource file
readRc

## show the names in the listbox
foreach name [array names userarray] {
    .names insert end $name
}

## find out the local machine's address
whoami

## do key bindings
bind .names <Double-1> {
	send [selection get]
}

bind .names <Return> {
    if { [catch {selection get}] } {
	error { "you must select a name" }
    } else {
	send [selection get]
    }
}

#bind . <Return> {
#    send [selection get]
#}

bind .arbitrary <Return> {
    arbsend $whoname
}

## handle command line arguments
foreach option $argv {
    if {  $option == "-iconic" } {
	wm iconify .
    }
    
    if { $option == "-version" } {
	puts "tkbroadcast version $version"
	exit
    }
}

## set window title
wm title . "tkbc $version"
## set window icon
#wm iconbitmap . tkbroadcast.xpm

## main event loop to handle incoming
## messages and spawn message windows
if { [catch {set sockflag [socket -server { incoming } $myport]}] != 0 } {
    puts "port busy. Exiting...."
    exit
} else {
    exec echo [pid] > $env(HOME)/.tkbc
}


## schedule updates to metaserver
addMe
metaUpdate

while { 1 } {
    vwait sockflag
}


